## docker.io 1.10.3

=== Makefile ===
.PHONY: all binary build cross default docs docs-build docs-shell shell test test-docker-py test-integration-cli test-unit validate

# get OS/Arch of docker engine
DOCKER_OSARCH := $(shell bash -c 'source hack/make/.detect-daemon-osarch && echo $${DOCKER_ENGINE_OSARCH:+$$DOCKER_CLIENT_OSARCH}')
# default for linux/amd64 and others
DOCKERFILE := Dockerfile
# switch to different Dockerfile for linux/arm
ifeq ($(DOCKER_OSARCH), linux/arm)
	DOCKERFILE := Dockerfile.armhf
else
ifeq ($(DOCKER_OSARCH), linux/arm64)
	# TODO .arm64
	DOCKERFILE := Dockerfile.armhf
else
ifeq ($(DOCKER_OSARCH), linux/ppc64le)
	DOCKERFILE := Dockerfile.ppc64le
else
ifeq ($(DOCKER_OSARCH), linux/s390x)
	DOCKERFILE := Dockerfile.s390x
endif
endif
endif
endif
export DOCKERFILE

# env vars passed through directly to Docker's build scripts
# to allow things like `make DOCKER_CLIENTONLY=1 binary` easily
# `docs/sources/contributing/devenvironment.md ` and `project/PACKAGERS.md` have some limited documentation of some of these
DOCKER_ENVS := \
	-e BUILDFLAGS \
	-e DOCKER_CLIENTONLY \
	-e DOCKER_DEBUG \
	-e DOCKER_EXPERIMENTAL \
	-e DOCKERFILE \
	-e DOCKER_GRAPHDRIVER \
	-e DOCKER_REMAP_ROOT \
	-e DOCKER_STORAGE_OPTS \
	-e DOCKER_USERLANDPROXY \
	-e TESTDIRS \
	-e TESTFLAGS \
	-e TIMEOUT
# note: we _cannot_ add "-e DOCKER_BUILDTAGS" here because even if it's unset in the shell, that would shadow the "ENV DOCKER_BUILDTAGS" set in our Dockerfile, which is very important for our official builds

# to allow `make BIND_DIR=. shell` or `make BIND_DIR= test`
# (default to no bind mount if DOCKER_HOST is set)
# note: BINDDIR is supported for backwards-compatibility here
BIND_DIR := $(if $(BINDDIR),$(BINDDIR),$(if $(DOCKER_HOST),,bundles))
DOCKER_MOUNT := $(if $(BIND_DIR),-v "$(CURDIR)/$(BIND_DIR):/go/src/github.com/docker/docker/$(BIND_DIR)")


GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
DOCKER_IMAGE := docker-dev$(if $(GIT_BRANCH),:$(GIT_BRANCH))
DOCKER_DOCS_IMAGE := docker-docs$(if $(GIT_BRANCH),:$(GIT_BRANCH))

DOCKER_FLAGS := docker run --rm -i --privileged $(DOCKER_ENVS) $(DOCKER_MOUNT)

# if this session isn't interactive, then we don't want to allocate a
# TTY, which would fail, but if it is interactive, we do want to attach
# so that the user can send e.g. ^C through.
INTERACTIVE := $(shell [ -t 0 ] && echo 1 || echo 0)
ifeq ($(INTERACTIVE), 1)
	DOCKER_FLAGS += -t
endif

DOCKER_RUN_DOCKER := $(DOCKER_FLAGS) "$(DOCKER_IMAGE)"

default: binary

all: build
	$(DOCKER_RUN_DOCKER) hack/make.sh

binary: build
	$(DOCKER_RUN_DOCKER) hack/make.sh binary

build: bundles
	docker build -t "$(DOCKER_IMAGE)" -f "$(DOCKERFILE)" .

bundles:
	mkdir bundles

cross: build
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary binary cross

deb: build
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary build-deb

docs:
	$(MAKE) -C docs docs

rpm: build
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary build-rpm

shell: build
	$(DOCKER_RUN_DOCKER) bash

test: build
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary cross test-unit test-integration-cli test-docker-py

test-docker-py: build
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-docker-py

test-integration-cli: build
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-integration-cli

test-unit: build
	$(DOCKER_RUN_DOCKER) hack/make.sh test-unit

validate: build
	$(DOCKER_RUN_DOCKER) hack/make.sh validate-dco validate-gofmt validate-pkg validate-lint validate-test validate-toml validate-vet validate-vendor

=== vendor/src/github.com/boltdb/bolt/Makefile ===
TEST=.
BENCH=.
COVERPROFILE=/tmp/c.out
BRANCH=`git rev-parse --abbrev-ref HEAD`
COMMIT=`git rev-parse --short HEAD`
GOLDFLAGS="-X main.branch $(BRANCH) -X main.commit $(COMMIT)"

default: build

bench:
	go test -v -test.run=NOTHINCONTAINSTHIS -test.bench=$(BENCH)

# http://cloc.sourceforge.net/
cloc:
	@cloc --not-match-f='Makefile|_test.go' .

cover: fmt
	go test -coverprofile=$(COVERPROFILE) -test.run=$(TEST) $(COVERFLAG) .
	go tool cover -html=$(COVERPROFILE)
	rm $(COVERPROFILE)

cpuprofile: fmt
	@go test -c
	@./bolt.test -test.v -test.run=$(TEST) -test.cpuprofile cpu.prof

# go get github.com/kisielk/errcheck
errcheck:
	@echo "=== errcheck ==="
	@errcheck github.com/boltdb/bolt

fmt:
	@go fmt ./...

get:
	@go get -d ./...

build: get
	@mkdir -p bin
	@go build -ldflags=$(GOLDFLAGS) -a -o bin/bolt ./cmd/bolt

test: fmt
	@go get github.com/stretchr/testify/assert
	@echo "=== TESTS ==="
	@go test -v -cover -test.run=$(TEST)
	@echo ""
	@echo ""
	@echo "=== CLI ==="
	@go test -v -test.run=$(TEST) ./cmd/bolt
	@echo ""
	@echo ""
	@echo "=== RACE DETECTOR ==="
	@go test -v -race -test.run="TestSimulate_(100op|1000op)"

.PHONY: bench cloc cover cpuprofile fmt memprofile test

=== vendor/src/github.com/docker/notary/Makefile ===
# Set an output prefix, which is the local directory if not specified
PREFIX?=$(shell pwd)

# Populate version variables
# Add to compile time flags
NOTARY_PKG := github.com/docker/notary
NOTARY_VERSION := $(shell cat NOTARY_VERSION)
GITCOMMIT := $(shell git rev-parse --short HEAD)
GITUNTRACKEDCHANGES := $(shell git status --porcelain --untracked-files=no)
ifneq ($(GITUNTRACKEDCHANGES),)
GITCOMMIT := $(GITCOMMIT)-dirty
endif
CTIMEVAR=-X $(NOTARY_PKG)/version.GitCommit=$(GITCOMMIT) -X $(NOTARY_PKG)/version.NotaryVersion=$(NOTARY_VERSION)
GO_LDFLAGS=-ldflags "-w $(CTIMEVAR)"
GO_LDFLAGS_STATIC=-ldflags "-w $(CTIMEVAR) -extldflags -static"
GOOSES = darwin freebsd linux
GOARCHS = amd64
NOTARY_BUILDTAGS ?= pkcs11
GO_EXC = go
NOTARYDIR := /go/src/github.com/docker/notary

# check to be sure pkcs11 lib is always imported with a build tag
GO_LIST_PKCS11 := $(shell go list -e -f '{{join .Deps "\n"}}' ./... | xargs go list -e -f '{{if not .Standard}}{{.ImportPath}}{{end}}' | grep -q pkcs11)
ifeq ($(GO_LIST_PKCS11),)
$(info pkcs11 import was not found anywhere without a build tag, yay)
else
$(error You are importing pkcs11 somewhere and not using a build tag)
endif

_empty :=
_space := $(empty) $(empty)

# go cover test variables
COVERDIR=.cover
COVERPROFILE?=$(COVERDIR)/cover.out
COVERMODE=count
PKGS ?= $(shell go list ./... | tr '\n' ' ')

GO_VERSION = $(shell go version | awk '{print $$3}')

.PHONY: clean all fmt vet lint build test binaries cross cover docker-images notary-dockerfile
.DELETE_ON_ERROR: cover
.DEFAULT: default

go_version:
ifeq (,$(findstring go1.5.,$(GO_VERSION)))
	$(error Requires go version 1.5.x - found $(GO_VERSION))
else
	@echo
endif


all: AUTHORS clean fmt vet fmt lint build test binaries

AUTHORS: .git/HEAD
	git log --format='%aN <%aE>' | sort -fu > $@

# This only needs to be generated by hand when cutting full releases.
version/version.go:
	./version/version.sh > $@

${PREFIX}/bin/notary-server: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@godep go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-server

${PREFIX}/bin/notary: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@godep go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary

${PREFIX}/bin/notary-signer: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@godep go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-signer

vet: go_version
	@echo "+ $@"
ifeq ($(shell uname -s), Darwin)
	@test -z "$(shell find . -iname *test*.go | grep -v _test.go | grep -v Godeps | xargs echo "This file should end with '_test':"  | tee /dev/stderr)"
else
	@test -z "$(shell find . -iname *test*.go | grep -v _test.go | grep -v Godeps | xargs -r echo "This file should end with '_test':"  | tee /dev/stderr)"
endif
	@test -z "$$(go tool vet -printf=false . 2>&1 | grep -v Godeps/_workspace/src/ | tee /dev/stderr)"

fmt:
	@echo "+ $@"
	@test -z "$$(gofmt -s -l .| grep -v .pb. | grep -v Godeps/_workspace/src/ | tee /dev/stderr)"

lint:
	@echo "+ $@"
	@test -z "$$(golint ./... | grep -v .pb. | grep -v Godeps/_workspace/src/ | tee /dev/stderr)"

build: go_version
	@echo "+ $@"
	@go build -tags "${NOTARY_BUILDTAGS}" -v ${GO_LDFLAGS} ./...

# When running `go test ./...`, it runs all the suites in parallel, which causes
# problems when running with a yubikey
test: TESTOPTS =
test: go_version
	@echo Note: when testing with a yubikey plugged in, make sure to include 'TESTOPTS="-p 1"'
	@echo "+ $@ $(TESTOPTS)"
	@echo
	go test -tags "${NOTARY_BUILDTAGS}" $(TESTOPTS) ./...

test-full: TESTOPTS =
test-full: vet lint
	@echo Note: when testing with a yubikey plugged in, make sure to include 'TESTOPTS="-p 1"'
	@echo "+ $@"
	@echo
	go test -tags "${NOTARY_BUILDTAGS}" $(TESTOPTS) -v ./...

protos:
	@protoc --go_out=plugins=grpc:. proto/*.proto

# This allows coverage for a package to come from tests in different package.
# Requires that the following:
# go get github.com/wadey/gocovmerge; go install github.com/wadey/gocovmerge
#
# be run first

define gocover
$(GO_EXC) test $(OPTS) $(TESTOPTS) -covermode="$(COVERMODE)" -coverprofile="$(COVERDIR)/$(subst /,-,$(1)).$(subst $(_space),.,$(NOTARY_BUILDTAGS)).coverage.txt" "$(1)" || exit 1;
endef

gen-cover: go_version
	@mkdir -p "$(COVERDIR)"
	$(foreach PKG,$(PKGS),$(call gocover,$(PKG)))
	rm -f "$(COVERDIR)"/*testutils*.coverage.txt

# Generates the cover binaries and runs them all in serial, so this can be used
# run all tests with a yubikey without any problems
cover: GO_EXC := go
       OPTS = -tags "${NOTARY_BUILDTAGS}" -coverpkg "$(shell ./coverpkg.sh $(1) $(NOTARY_PKG))"
cover: gen-cover covmerge
	@go tool cover -html="$(COVERPROFILE)"

# Generates the cover binaries and runs them all in serial, so this can be used
# run all tests with a yubikey without any problems
ci: OPTS = -tags "${NOTARY_BUILDTAGS}" -race -coverpkg "$(shell ./coverpkg.sh $(1) $(NOTARY_PKG))"
    GO_EXC := godep go
# Codecov knows how to merge multiple coverage files, so covmerge is not needed
ci: gen-cover

yubikey-tests: override PKGS = github.com/docker/notary/cmd/notary github.com/docker/notary/trustmanager/yubikey
yubikey-tests: ci

covmerge:
	@gocovmerge $(shell ls -1 $(COVERDIR)/* | tr "\n" " ") > $(COVERPROFILE)
	@go tool cover -func="$(COVERPROFILE)"

clean-protos:
	@rm proto/*.pb.go

binaries: go_version ${PREFIX}/bin/notary-server ${PREFIX}/bin/notary ${PREFIX}/bin/notary-signer
	@echo "+ $@"

define template
mkdir -p ${PREFIX}/cross/$(1)/$(2);
GOOS=$(1) GOARCH=$(2) CGO_ENABLED=0 go build -o ${PREFIX}/cross/$(1)/$(2)/notary -a -tags "static_build netgo" -installsuffix netgo ${GO_LDFLAGS_STATIC} ./cmd/notary;
endef

cross: go_version
	$(foreach GOARCH,$(GOARCHS),$(foreach GOOS,$(GOOSES),$(call template,$(GOOS),$(GOARCH))))


notary-dockerfile:
	@docker build --rm --force-rm -t notary .

server-dockerfile:
	@docker build --rm --force-rm -f server.Dockerfile -t notary-server .

signer-dockerfile:
	@docker build --rm --force-rm -f signer.Dockerfile -t notary-signer .

docker-images: notary-dockerfile server-dockerfile signer-dockerfile

shell: notary-dockerfile
	docker run --rm -it -v $(CURDIR)/cross:$(NOTARYDIR)/cross -v $(CURDIR)/bin:$(NOTARYDIR)/bin notary bash


clean:
	@echo "+ $@"
	@rm -rf "$(COVERDIR)"
	@rm -rf "${PREFIX}/bin/notary-server" "${PREFIX}/bin/notary" "${PREFIX}/bin/notary-signer"

=== vendor/src/github.com/vishvananda/netlink/Makefile ===
DIRS := \
	. \
	nl

DEPS = \
	github.com/vishvananda/netns

uniq = $(if $1,$(firstword $1) $(call uniq,$(filter-out $(firstword $1),$1)))
testdirs = $(call uniq,$(foreach d,$(1),$(dir $(wildcard $(d)/*_test.go))))
goroot = $(addprefix ../../../,$(1))
unroot = $(subst ../../../,,$(1))
fmt = $(addprefix fmt-,$(1))

all: fmt test

$(call goroot,$(DEPS)):
	go get $(call unroot,$@)

.PHONY: $(call testdirs,$(DIRS))
$(call testdirs,$(DIRS)):
	sudo -E go test -v github.com/vishvananda/netlink/$@

$(call fmt,$(call testdirs,$(DIRS))):
	! gofmt -l $(subst fmt-,,$@)/*.go | grep ''

.PHONY: fmt
fmt: $(call fmt,$(call testdirs,$(DIRS)))

test: fmt $(call goroot,$(DEPS)) $(call testdirs,$(DIRS))

=== debian/changelog ===
docker.io (1.10.3-0ubuntu6) xenial; urgency=medium

  * Clean up some DEP3 patch metadata (especially "Origin" and "Forwarded")

 -- Tianon Gravi <tianon@debian.org>  Wed, 20 Apr 2016 14:19:16 -0700

docker.io (1.10.3-0ubuntu5) xenial; urgency=medium

  * Rebuild to pick up fixes in golang-1.6 1.6-0ubuntu5.
  * Add golang version to Built-Using in docker package.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 11 Apr 2016 14:15:45 +1200

docker.io (1.10.3-0ubuntu4) xenial; urgency=medium

  * Drop d/patches/libnetwork-s390x.patch, no longer needed after golang
    updates.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 04 Apr 2016 16:27:28 +1200

docker.io (1.10.3-0ubuntu3) xenial; urgency=medium

  * Do not use aufs in a lxd container.  (LP: #1560685)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 31 Mar 2016 21:30:49 -0500

docker.io (1.10.3-0ubuntu2) xenial; urgency=medium

  * Add "TasksMax=infinity" patch for newer kernel+systemd
  * Add support to DEP8 test script for passing *_proxy environment variables
    forward appropriately

 -- Tianon Gravi <tianon@debian.org>  Mon, 28 Mar 2016 15:20:51 -0700

docker.io (1.10.3-0ubuntu1) xenial; urgency=medium

  [ Joseph Ferguson ]
  * Update "Homepage" to "dockerproject.org" (versus ".com" which now redirects)
  * Update "Vcs-Browser" to use https
  * Add missing "jq" to DEP8 test dependencies
  * Add a few multiarch build system patches to enable running the integration
    tests

 -- Dustin Kirkland <kirkland@ubuntu.com>  Thu, 24 Mar 2016 16:08:42 -0500

docker.io (1.10.2-0ubuntu4) xenial; urgency=medium

  * Add debian/patches/upstream-delegate.patch: Add "Delegate=yes" to docker's
    service file, so that it can manage cgroups by itself. Patch cherry-picked
    from upstream master. (LP: #1546214)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Sun, 13 Mar 2016 22:50:51 +0100

docker.io (1.10.2-0ubuntu3) xenial; urgency=medium

  * debian/control:
    - drop the any- prefix on build arches;  seems that any-armhf isn't
      defined, so armhf builds did not trigger

 -- Dustin Kirkland <kirkland@ubuntu.com>  Thu, 10 Mar 2016 14:41:00 -0500

docker.io (1.10.2-0ubuntu2) xenial; urgency=medium

  * debian/control:
    - disable powerpc build for now

 -- Dustin Kirkland <kirkland@ubuntu.com>  Thu, 10 Mar 2016 10:39:16 -0500

docker.io (1.10.2-0ubuntu1) xenial; urgency=medium

  * Update to 1.10.2 upstream release (LP: #1552790)
    - include upstream's vendored bits (explicitly relying on upstream for
      security updates and support)
    - patches for enabling Docker-in-LXD (still pending upstream)
    - patches for s390x support

 -- Tianon Gravi <tianon@debian.org>  Tue, 01 Mar 2016 14:21:20 -0800

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Paul Tagliamonte <paultag@debian.org>
Uploaders: Docker Packaging Team <docker-maint@lists.alioth.debian.org>,
           Tianon Gravi <tianon@debian.org>,
           Johan Euphrosine <proppy@google.com>
Build-Depends: bash-completion,
               btrfs-tools,
               debhelper (>=9),
               dh-systemd,
               go-md2man (>= 1.0.3~),
               golang-go (>= 2:1.4~) | gccgo (>= 4:5~),
               libapparmor-dev,
               libdevmapper-dev (>= 2:1.02.68~)
Standards-Version: 3.9.6
Homepage: https://dockerproject.org
Vcs-Git: git://anonscm.debian.org/docker/docker.io.git
Vcs-Browser: https://anonscm.debian.org/cgit/docker/docker.io.git

Package: docker.io
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: adduser, iptables, ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
Recommends: ca-certificates,
            cgroupfs-mount | cgroup-lite,
            git,
            ubuntu-fan,
            xz-utils,
            ${apparmor:Recommends}
Replaces: docker (<< 1.5~)
Breaks: docker (<< 1.5~)
Suggests: aufs-tools, btrfs-tools, debootstrap, lxc, rinse, zfs-fuse | zfsutils
Built-Using: ${misc:Built-Using}, ${libc:Built-Using}, ${golang:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: vim-syntax-docker
Architecture: all
Depends: vim, ${misc:Depends}
Recommends: vim-addon-manager
Suggests: docker.io
Description: Docker container engine - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing Dockerfiles
 from the Docker container engine.

Package: golang-github-docker-docker-dev
Architecture: all
Depends: ${misc:Depends}
Built-Using: ${misc:Built-Using}
Replaces: golang-docker-dev (<< 1.8.2~ds1-1~)
Breaks: golang-docker-dev (<< 1.8.2~ds1-1~)
Provides: golang-docker-dev
Description: Externally reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: golang-docker-dev
Section: oldlibs
Architecture: all
Depends: golang-github-docker-docker-dev, ${misc:Depends}
Description: Transitional package for golang-github-docker-docker-dev
 This is a transitional package to ease upgrades to the
 golang-github-docker-docker-dev package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DOCKER_GOPKG := github.com/docker/docker

# MUST STAY IN SYNC WITH LIST IN "debian/helpers/download-libcontainer"
MULTI_ORIG_GOPKGS := \
	github.com/docker/libnetwork

# the list of Go packages to include in golang-github-docker-docker-dev
DEV_GOPKGS := \
	github.com/docker/docker/pkg

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
GOPATH_PACKAGED := /usr/share/gocode
EXTRA_GOPATH := $(GOPATH_PACKAGED)

# if we've got the vendored source not purged, let's use it (normally purged via debian/repack.sh)
ifneq (, $(wildcard $(CURDIR)/vendor/src))
	EXTRA_GOPATH := $(CURDIR)/vendor
endif

export GOPATH := $(OUR_GOPATH):$(EXTRA_GOPATH)

# a few helpful variables for deduplication
DOCKER_BINPATH := /usr/bin/docker
DOCKER_VERSION := $(shell cat VERSION)

export DOCKER_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh $(DOCKER_VERSION))
export BUILDTIME := $(shell dpkg-parsechangelog -SDate)
export DOCKER_INITPATH := /usr/lib/docker.io/dockerinit

# AppArmor can be optionally used in Debian and is there by default in Ubuntu, so we need support for it compiled into our binary
# same story with SELinux
export DOCKER_BUILDTAGS := apparmor selinux

# since "gccgo" doesn't ship the "dist" go tool (and isn't likely to start), let's use that for now to detect gc vs gccgo
DOCKER_BUILD_TARGET := $(shell go tool dist env > /dev/null 2>&1 && echo dynbinary || echo dyngccgo)


APPARMOR_RECOMMENDS := $(shell dpkg-vendor --is Ubuntu && echo apparmor)
BUILT_LIBC := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)
BUILT_GOLANG := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W $$(dpkg --search $$(readlink -f /usr/bin/go) | cut -d: -f1))

override_dh_gencontrol:
	echo 'apparmor:Recommends=$(APPARMOR_RECOMMENDS)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(BUILT_LIBC)' >> debian/docker.io.substvars
	echo 'golang:Built-Using=$(BUILT_GOLANG)' >> debian/docker.io.substvars
	dh_gencontrol


setup-gopath:
	# we need to make sure all deps are in our GOPATH
	mkdir -p "$(OUR_GOPATH)"
	@set -ex; \
		for package in $(DOCKER_GOPKG) $(MULTI_ORIG_GOPKGS); do \
			for gopath in $(subst :, ,$(GOPATH)); do \
				if [ -d "$$gopath/src/$$package" ]; then \
					continue 2; \
				fi; \
			done; \
			[ $$package = $(DOCKER_GOPKG) ] \
				&& src=. \
				|| src=$$(basename $$package); \
			mkdir -p "$(OUR_GOPATH)/src/$$(dirname $$package)"; \
			ln -sfT "$$(readlink -f "$$src")" "$(OUR_GOPATH)/src/$$package"; \
		done

override_dh_auto_build:
	@bash -c '{ [ "$$DOCKER_GITCOMMIT" ]; } || { echo; echo "error: missing DOCKER_GITCOMMIT - see debian/upstream-version-gitcommits"; echo; exit 2; } >&2'
	
	./debian/rules setup-gopath
	
	# build "docker" and "dockerinit"
	./hack/make.sh $(DOCKER_BUILD_TARGET)
	
	# compile man pages
	./man/md2man-all.sh -q


override_dh_auto_install:
	# install docker binary
	mkdir -p debian/docker.io/$(dir $(DOCKER_BINPATH))
	cp -aT bundles/$(DOCKER_VERSION)/$(DOCKER_BUILD_TARGET)/docker-$(DOCKER_VERSION) debian/docker.io/$(DOCKER_BINPATH)
	
	# install dockerinit binary
	mkdir -p debian/docker.io/$(dir $(DOCKER_INITPATH))
	cp -aT bundles/$(DOCKER_VERSION)/$(DOCKER_BUILD_TARGET)/dockerinit-$(DOCKER_VERSION) debian/docker.io/$(DOCKER_INITPATH)
	
	# Most of the source of docker does not make a library,
	#   so only ship the reusable parts (and in a separate package).
	@set -ex; \
		for package in $(DEV_GOPKGS); do \
			mkdir -p "debian/golang-github-docker-docker-dev/$(GOPATH_PACKAGED)/src/$$package"; \
			cp -aT "$$(readlink -f "$(OUR_GOPATH)/src/$$package")" "debian/golang-github-docker-docker-dev/$(GOPATH_PACKAGED)/src/$$package"; \
		done


override_dh_strip:
	# the SHA1 of dockerinit is important: don't strip it
	# also, Go has lots of problems with stripping, so just don't


override_dh_auto_test:


override_dh_installinit:
	dh_installinit --name=docker --no-restart-on-upgrade


override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev --priority=z80


override_dh_auto_clean:
	dh_auto_clean
	
	# OUR_GOPATH is created by us
	rm -rf "$(OUR_GOPATH)"
	
	# autogen is created by hack/make.sh
	# bundles is created by hack/make.sh
	# dockerversion/version_autogen.go is created by hack/make.sh
	# man/man*/ is created by man/md2man-all.sh
	rm -rf autogen bundles dockerversion/version_autogen.go man/man*/


%:
	dh $@ --with=systemd,bash-completion

=== debian/tests/control ===
Tests: integration
Depends: ca-certificates, curl, git, golang-check.v1-dev, jq, @, @builddeps@
Restrictions: allow-stderr isolation-machine needs-root rw-build-tree

## docker.io 1.11.2~ds1

=== debian/changelog ===
docker.io (1.11.2~ds1-5) unstable; urgency=medium

  * Skip racy "TestRunCommandWithOutputAndTimeoutKilled" during build (see also
    https://github.com/docker/docker/issues/22965)

 -- Tianon Gravi <tianon@debian.org>  Tue, 12 Jul 2016 07:46:35 -0700

docker.io (1.11.2~ds1-4) unstable; urgency=medium

  [ Tianon Gravi ]
  * Add new script to generate Build-Depends based on "go list" instead of
    "hack/vendor.sh" (and update Build-Depends using it)
  * Update "/etc/default/docker" text to aggressively discourage use, linking to
    upstream's documentation for the recommended alternatives
    ("/etc/docker/daemon.json" and systemd drop-ins)
  * Update gbp.conf for pristine-tar usage now that we're no longer multi-orig
  * Remove "/var/lib/docker" upon purge (Closes: #739257)

  [ Dmitry Smirnov ]
  * Add support for DEB_BUILD_OPTIONS=nocheck in debian/rules

 -- Tianon Gravi <tianon@debian.org>  Mon, 11 Jul 2016 22:09:01 -0700

docker.io (1.11.2~ds1-3) unstable; urgency=medium

  * Team upload.
  * Updated "skip-privileged-unit-tests.patch" to skip more privileged
    tests in order to fix FTBFS in pbuilder.
  * Install "opts" directory to -dev package.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 09 Jul 2016 13:49:02 +1000

docker.io (1.11.2~ds1-2) unstable; urgency=medium

  * Add Tim Potter (tpot) and Dmitry Smirnov (onlyjob) to debian/copyright; they
    were instrumental in getting 1.11 into the archive!
  * Fix golang-github-docker-docker-dev install location (Closes: #830478);
    thanks nicoo!

 -- Tianon Gravi <tianon@debian.org>  Fri, 08 Jul 2016 08:47:44 -0700

docker.io (1.11.2~ds1-1) unstable; urgency=medium

  * Update to 1.11.2 upstream release
    (Closes: #806887, #820149, #822628, #812838)
  * Add NEWS file describing the AUFS issue and the unfortunate possible
    "solutions" (Closes: #799386, #805725)
  * Add "/etc/docker" to the directories explicitly installed by the package
    to help combat issues like #806261
  * Update "Homepage" to "dockerproject.org" (versus ".com" which now redirects)
  * Update "Vcs-Browser" to use https
  * Shrink the Ubuntu delta by pulling in many of the changes
  * Replace "btrfs-tools" relations with "btrfs-progs" (Closes: #824833)
  * Adjust "repack.sh" to allow keeping minor bits of vendor/
  * Fix bad URL in README (Closes: #816844); thanks Clint!
  * Move documentation to dedicated "docker-doc" package
  * Refresh patches, add minor patch to get unit tests running
  * Use gccgo on non-golang architectures (Closes: #785093)
  * Use "dh-golang" to calculate "Built-Using" more accurately
  * Add simple "basic-smoke" DEP8 test

 -- Tianon Gravi <tianon@debian.org>  Mon, 04 Jul 2016 09:59:44 -0700

=== debian/control ===
--- 
+++ 
@@ -1,37 +1,104 @@
 Source: docker.io
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Paul Tagliamonte <paultag@debian.org>
+Maintainer: Paul Tagliamonte <paultag@debian.org>
 Uploaders: Docker Packaging Team <docker-maint@lists.alioth.debian.org>,
-           Tianon Gravi <tianon@debian.org>,
-           Johan Euphrosine <proppy@google.com>
+           Tianon Gravi <tianon@debian.org>
+Build-Conflicts: golang-github-docker-docker-dev
 Build-Depends: bash-completion,
-               btrfs-tools,
-               debhelper (>=9),
+               btrfs-progs,
+               ca-certificates,
+               debhelper (>= 9),
+               dh-exec,
+               dh-golang (>= 1.14~),
                dh-systemd,
+               git,
                go-md2man (>= 1.0.3~),
-               golang-go (>= 2:1.4~) | gccgo (>= 4:5~),
+               golang-any (>= 2:1.6~) | golang-1.6-go,
+               golang-dbus-dev (>= 3~) | golang-github-godbus-dbus-dev (>= 3~),
+               golang-dns-dev (>= 0.0~git20151201~) | golang-github-miekg-dns-dev (>= 0.0~git20151201~),
+               golang-ed25519-dev (>= 0~20140907~) | golang-github-agl-ed25519-dev (>= 0~20140907~),
+               golang-etcd-server-dev (>= 2.2.0~) | golang-github-coreos-etcd-dev (>= 2.2.0~),
+               golang-github-armon-go-metrics-dev (>= 0.0~git20150106~),
+               golang-github-aws-aws-sdk-go-dev (>= 0.9.9~),
+               golang-github-boltdb-bolt-dev (>= 1.2.0~),
+               golang-github-burntsushi-toml-dev (>= 0.0~git20150127~),
+               golang-github-coreos-go-systemd-dev (>= 4~),
+               golang-github-deckarep-golang-set-dev (>= 0.0~git20141121~),
+               golang-github-docker-containerd-dev (>= 0.2.1~),
+               golang-github-docker-distribution-dev (>= 2.4.1~),
+               golang-github-docker-engine-api-dev (>= 0.3.3~),
+               golang-github-docker-go-connections-dev (>= 0.2.0~),
+               golang-github-docker-go-dev (>= 0.0~git20151102~),
+               golang-github-docker-go-units-dev (>= 0.0~git20151218~),
+               golang-github-docker-libkv-dev (>= 0.0~git20151014~),
+               golang-github-docker-libnetwork-dev (>= 0.7.0~rc.6~),
+               golang-github-docker-libtrust-dev (>= 0.0~git20150526~),
+               golang-github-fluent-fluent-logger-golang-dev (>= 1.1.0~),
+               golang-github-fsnotify-fsnotify-dev (>= 1.2.0~) | golang-gopkg-fsnotify.v1-dev (>= 1.2.0~),
+               golang-github-gorilla-context-dev (>= 0.0~git20140604~),
+               golang-github-gorilla-mux-dev (>= 0.0~git20140926~),
+               golang-github-graylog2-go-gelf-dev (>= 0.0~git20160208~),
+               golang-github-hashicorp-consul-dev (>= 0.5.2~),
+               golang-github-hashicorp-go-msgpack-dev (>= 0.0~git20140221~),
+               golang-github-hashicorp-memberlist-dev (>= 0.0~git20150107~),
+               golang-github-hashicorp-serf-dev (>= 0.0~git20150212~),
+               golang-github-imdario-mergo-dev (>= 0.2.1~),
+               golang-github-kr-pty-dev (>= 0.0~git20150511~),
+               golang-github-mattn-go-shellwords-dev (>= 1.0.0~),
+               golang-github-mattn-go-sqlite3-dev (>= 1.1.0~),
+               golang-github-miekg-pkcs11-dev (>= 0.0~git20160222~),
+               golang-github-opencontainers-runc-dev (>= 0.1.0~),
+               golang-github-opencontainers-specs-dev (>= 0.0~git20160422~),
+               golang-github-philhofer-fwd-dev (>= 0.0~git20150401~),
+               golang-github-racksec-srslog-dev (>= 0.0~git20160120~),
+               golang-github-samuel-go-zookeeper-dev (>= 0.0~git20150415~),
+               golang-github-sirupsen-logrus-dev (>= 0.9.0~),
+               golang-github-tchap-go-patricia-dev (>= 2.1.0~),
+               golang-github-tinylib-msgp-dev (>= 0.0~git20150407~),
+               golang-github-ugorji-go-codec-dev (>= 0.0~git20150803~) | golang-github-ugorji-go-dev (>= 0.0~git20150803~),
+               golang-github-vaughan0-go-ini-dev (>= 0.0~git20130923~),
+               golang-github-vbatts-tar-split-dev (>= 0.9.11~),
+               golang-github-vdemeester-shakers-dev (>= 0.0~git20160210~),
+               golang-github-vishvananda-netlink-dev (>= 0.0~git20160214~),
+               golang-github-vishvananda-netns-dev (>= 0.0~git20150710~),
+               golang-go-zfs-dev (>= 2.1.1~) | golang-github-mistifyio-go-zfs-dev (>= 2.1.1~),
+               golang-gocapability-dev (>= 0.0~git20150614~) | golang-github-syndtr-gocapability-dev (>= 0.0~git20150614~),
+               golang-golang-x-net-dev (>= 0.0~git20160407~),
+               golang-golang-x-oauth2-dev (>= 0.0~git20151203~),
+               golang-google-api-dev (>= 0.0~git20151216~),
+               golang-google-cloud-dev (>= 0.0~git20151216~),
+               golang-google-grpc-dev (>= 0.0~git20151216~),
+               golang-gopkg-check.v1-dev (>= 0.0~git20160311~) | golang-github-go-check-check-dev (>= 0.0~git20160311~),
+               golang-goprotobuf-dev (>= 0.0~git20151207~) | golang-github-golang-protobuf-dev (>= 0.0~git20151207~),
                libapparmor-dev,
-               libdevmapper-dev (>= 2:1.02.68~)
-Standards-Version: 3.9.6
+               libdevmapper-dev (>= 2:1.02.68~),
+               pkg-config,
+               procps
+Standards-Version: 3.9.8
 Homepage: https://dockerproject.org
-Vcs-Git: git://anonscm.debian.org/docker/docker.io.git
+Vcs-Git: https://anonscm.debian.org/git/docker/docker.io.git
 Vcs-Browser: https://anonscm.debian.org/cgit/docker/docker.io.git
+XS-Go-Import-Path: github.com/docker/docker
 
 Package: docker.io
-Architecture: amd64 arm64 armhf i386 ppc64el s390x
-Depends: adduser, iptables, ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
+Architecture: linux-any
+Depends: adduser,
+         containerd (>= 0.2.1~),
+         iptables,
+         runc (>= 0.1.0~),
+         ${misc:Depends},
+         ${perl:Depends},
+         ${shlibs:Depends}
 Recommends: ca-certificates,
             cgroupfs-mount | cgroup-lite,
             git,
-            ubuntu-fan,
             xz-utils,
             ${apparmor:Recommends}
 Replaces: docker (<< 1.5~)
 Breaks: docker (<< 1.5~)
-Suggests: aufs-tools, btrfs-tools, debootstrap, lxc, rinse, zfs-fuse | zfsutils
-Built-Using: ${misc:Built-Using}, ${libc:Built-Using}, ${golang:Built-Using}
+Suggests: aufs-tools, btrfs-progs, debootstrap, lxc, rinse, zfs-fuse | zfsutils
+Built-Using: ${misc:Built-Using}, ${libc:Built-Using}
 Description: Linux container runtime
  Docker complements kernel namespacing with a high-level API which operates at
  the process level. It runs unix processes with strong guarantees of isolation
@@ -60,7 +127,20 @@
 
 Package: golang-github-docker-docker-dev
 Architecture: all
-Depends: ${misc:Depends}
+Depends: golang-github-docker-go-connections-dev,
+         golang-github-docker-go-units-dev,
+         golang-github-docker-libkv-dev,
+         golang-github-fsnotify-fsnotify-dev,
+         golang-github-gorilla-mux-dev,
+         golang-github-mattn-go-shellwords-dev,
+         golang-github-mattn-go-sqlite3-dev,
+         golang-github-opencontainers-runc-dev,
+         golang-github-sirupsen-logrus-dev,
+         golang-github-tchap-go-patricia-dev,
+         golang-github-vdemeester-shakers-dev,
+         golang-golang-x-net-dev,
+         golang-gopkg-check.v1-dev,
+         ${misc:Depends}
 Built-Using: ${misc:Built-Using}
 Replaces: golang-docker-dev (<< 1.8.2~ds1-1~)
 Breaks: golang-docker-dev (<< 1.8.2~ds1-1~)
@@ -72,8 +152,33 @@
 
 Package: golang-docker-dev
 Section: oldlibs
+Priority: extra
 Architecture: all
 Depends: golang-github-docker-docker-dev, ${misc:Depends}
 Description: Transitional package for golang-github-docker-docker-dev
  This is a transitional package to ease upgrades to the
  golang-github-docker-docker-dev package. It can safely be removed.
+
+Package: docker-doc
+Provides: docker.io-doc
+Section: doc
+Architecture: all
+Depends: ${misc:Depends}
+Description: Linux container runtime -- documentation
+ Docker complements kernel namespacing with a high-level API which operates at
+ the process level. It runs unix processes with strong guarantees of isolation
+ and repeatability across servers.
+ .
+ Docker is a great building block for automating distributed systems:
+ large-scale web deployments, database clusters, continuous deployment systems,
+ private PaaS, service-oriented architectures, etc.
+ .
+ This package contains the daemon and client. Using docker.io on non-amd64 hosts
+ is not supported at this time. Please be careful when using it on anything
+ besides amd64.
+ .
+ Also, note that kernel version 3.8 or above is required for proper operation of
+ the daemon process, and that any lower versions may have subtle and/or glaring
+ issues.
+ .
+ This package provides documentation for Docker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_GOPKG := github.com/docker/docker
export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_EXCLUDES := \
	integration-cli \
	vendor

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)

# helpful variables for deduplication
export DOCKER_VERSION := $(shell cat VERSION)

export DOCKER_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh $(DOCKER_VERSION))
export BUILDTIME := $(shell dpkg-parsechangelog -SDate)

# have "make.sh" keep "bundle/$(DOCKER_VERSION)" around between runs (we clean it up appropriately ourselves)
export KEEPBUNDLE := 1

# AppArmor can be optionally used in Debian and is there by default in Ubuntu, so we need support for it compiled into our binary
# same story with SELinux
export DOCKER_BUILDTAGS := apparmor selinux

# since "gccgo" doesn't ship the "dist" go tool (and isn't likely to start), let's use that for now to detect gc vs gccgo
export DOCKER_BUILD_TARGET := $(shell go tool dist env > /dev/null 2>&1 && echo dynbinary || echo dyngccgo)

# prefer Go 1.6 explicitly if it's available (golang-1.6-go)
export PATH := /usr/lib/go-1.6/bin:$(PATH)


APPARMOR_RECOMMENDS := $(shell dpkg-vendor --is Ubuntu && echo apparmor)
BUILT_LIBC := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)

override_dh_gencontrol:
	echo 'apparmor:Recommends=$(APPARMOR_RECOMMENDS)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(BUILT_LIBC)' >> debian/docker.io.substvars
	dh_gencontrol


override_dh_auto_configure:
	dh_auto_configure
	
ifneq (, $(wildcard $(CURDIR)/vendor/src))
	# prefer vendored deps (when they exist)
	rm -rf '$(OUR_GOPATH)/src/$(DH_GOPKG)/vendor' \
		&& mkdir '$(OUR_GOPATH)/src/$(DH_GOPKG)/vendor' \
		&& cd vendor/src \
		&& cp -r . '$(OUR_GOPATH)/src/$(DH_GOPKG)/vendor'
endif
	
	# make sure the bits modified at build-time are properly in our GOPATH
	rm -rf '$(OUR_GOPATH)/src/$(DH_GOPKG)/dockerversion'
	mkdir -p '$(OUR_GOPATH)/src/$(DH_GOPKG)'
	ln -sfT '$(CURDIR)/dockerversion' '$(OUR_GOPATH)/src/$(DH_GOPKG)/dockerversion'

override_dh_auto_build:
	@bash -c '{ [ "$$DOCKER_GITCOMMIT" ]; } || { echo; echo "error: missing DOCKER_GITCOMMIT - see debian/upstream-version-gitcommits"; echo; exit 2; } >&2'
	
	# build
	./hack/make.sh $(DOCKER_BUILD_TARGET)
	
	# compile man pages
	./man/md2man-all.sh -q


override_dh_install:
	## Do not install extra license files:
	dh_install -XLICENSE

override_dh_auto_install:
	# skip dh_auto_install to stop dh_golang trying to copy bits for /usr/share/gocode (we use dh_install/dh-exec for that)


override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# run unit tests
	cd '$(OUR_GOPATH)/src/$(DH_GOPKG)' \
		&& export TESTFLAGS='-test.short' \
		&& bash ./hack/make.sh test-unit
endif


override_dh_installinit:
	dh_installinit --name=docker --no-restart-on-upgrade


override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev --priority=z80


override_dh_auto_clean:
	dh_auto_clean
	
	# OUR_GOPATH is created by us
	rm -rf '$(OUR_GOPATH)'
	
	# autogen is created by hack/make.sh
	# bundles is created by hack/make.sh
	# dockerversion/version_autogen.go is created by hack/make.sh
	# man/man*/ is created by man/md2man-all.sh
	rm -rf autogen bundles dockerversion/version_autogen.go man/man*/


%:
	dh $@ --buildsystem=golang --with=systemd,bash-completion,golang --builddirectory='$(OUR_GOPATH)'

=== debian/tests/control ===
Tests: basic-smoke
Depends: debootstrap, debian-keyring, @
Restrictions: isolation-machine needs-root

#Tests: integration
#Depends: ca-certificates, curl, git, golang-check.v1-dev, jq, @, @builddeps@
#Restrictions: allow-stderr isolation-machine needs-root rw-build-tree
